<?php
header('Content-type: text/html; charset=ISO-8859-1'); 
error_reporting(E_ERROR | E_WARNING | E_PARSE);
include("dbconnect.php");

$debug=0;
$udpPort = 15556;
$loxoneUdpPort = 15557;
$header=0xdf;

$host= gethostname();
$serverIp = gethostbyname($host);
$broadcastAddress = substr($serverIp,0,strrpos($serverIp,".")).".255";


// Register Globals FIX
foreach (array('_GET', '_POST', '_COOKIE', '_SERVER') as $_SG) 
{
    foreach ($$_SG as $_SGK => $_SGV) 
    {
        $$_SGK = $_SGV;
    }
}

function discoverBusMembers()
{
	global $udpSocket;
	global $udpPort;
	
	query("DELETE from busmembers") or die(MYSQL_ERROR());
	
	createSocket();
  ob_implicit_flush(true);
  
  for ($i=0;$i<2;$i++)
  {
    broadcastIdentify();

    $timeout = time()+2;
    while(time()<$timeout)
    {
  	  $null = NULL;
  	  $socketArray = array($udpSocket);
  	  $num_changed_sockets = socket_select($socketArray, $null, $null, 0);
      if ($num_changed_sockets === false) logMe( "UDP socket_select hat Fehler gemeldet: ". socket_strerror(socket_last_error())."\n");
      else if ($num_changed_sockets > 0)
      {
      	$size=@socket_recvfrom($udpSocket,$data,65535,0,$ipaddress,$port);
        if ($data!=false && $data!='') handleUdpData($data, $ipaddress);
        else logMe(" keine daten $lb");
      }
    }
  }
}

function createSocket($useLoxonePort=0)
{
	global $udpSocket;
	global $udpPort;
	global $loxoneUdpPort;
	
	$myPort = $udpPort;
	
	if ($useLoxonePort==1) $myPort = $loxoneUdpPort;
	
  if (($udpSocket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP)) === false) die("UDP socket_create() fehlgeschlagen: Grund: " . socket_strerror(socket_last_error()));
  if (!socket_set_option($udpSocket, SOL_SOCKET, SO_REUSEADDR, 1)) die("UDP Could not set option SO_REUSEADDR to socket: ". socket_strerror(socket_last_error()) . PHP_EOL);
  if (!socket_set_nonblock($udpSocket)) die("UDP Could not set socket to non blocking mode: ". socket_strerror(socket_last_error()) . PHP_EOL);
  if (socket_bind($udpSocket, 0, $myPort) === false) traceError("UDP socket_bind() fehlgeschlagen: Grund: " . socket_strerror(socket_last_error($sock)));
}

function handleUdpData($data, $ipaddress)
{
	global $header;
	
  logMe("Received ".strlen($data)." bytes");
  
 
  if ( ord($data[0]) == $header && ord($data[1]) == $header && $data[2] == $data[3]&& $data[3] == $data[4])
  {
  	 $command = ord($data[2]);
  	 
  	 if ($command=="5") // IDENTIFY_RESPONSE
  	 {
  	 	 $version = ord($data[5]);
  	 	 $server = ord($data[6]); // 0 = WLAN Client 1 = Servermodul 2 = RS485 Client
  	 	 $address = (ord($data[7])<<24) + (ord($data[8])<<16) + (ord($data[9])<<8) + ord($data[10]); 
  	 	 $wifi = (ord($data[11])<<24) + (ord($data[12])<<16) + (ord($data[13])<<8) + ord($data[14]);
   	 	 $versionTaster = ord($data[15]).".".ord($data[16]);
   	 	 
  	 	 logMe("Client: version = $version version taster = $versionTaster server = $server address = $address wifi = $wifi");
  	 	 query("delete from busmembers where ip='$ipaddress' and address='$address'");
  	 	 query("REPLACE into busmembers (ip,address,version,server,wifi,versionTaster) values('$ipaddress', '$address','$version','$server','$wifi','$versionTaster')");
  	 }
  }
}

function broadcastIdentify()
{
	global $udpSocket;
	global $broadcastAddress;
	
	$binary_msg = "";
	$binary_msg.= chr(0xdf);
	$binary_msg.= chr(0xdf);
	$binary_msg.= chr(4);
	$binary_msg.= chr(4);
	$binary_msg.= chr(4);
	
	socket_sendto($udpSocket, $binary_msg, 5, 0, $broadcastAddress , 15556);
}

function sendLedCommand($brightness, $addr, $nr)
{
	createSocket(1);
	
	global $udpSocket;
	global $loxoneUdpPort;
	
	$erg = query("select ip from busmembers where server='1' limit 1");
	if ($obj=MYSQLi_FETCH_OBJECT($erg))
	{
		$binary_msg = $addr.".LED.".$nr.".".$brightness;
	
	  socket_sendto($udpSocket, $binary_msg, strlen($binary_msg), 0, $obj->ip , $loxoneUdpPort);
	}
	else echo "Kein Servermodul gefunden!<br>";
}

function sendConfiguration($longPressTime, $serverIp)
{
	createSocket();
	
	global $udpSocket;
	
	$erg = query("select ip from busmembers where server='1' limit 1");
	if ($obj=MYSQLi_FETCH_OBJECT($erg))
	{
	  $binary_msg.= chr(0xdf);
	  $binary_msg.= chr(0xdf);
	  $binary_msg.= chr(6);
	  $binary_msg.= chr(6);
	  $binary_msg.= chr(6);
	  $binary_msg.= chr($longPressTime);
	  $parts=explode(".",$serverIp);
	  if (count($parts)!=4) $binary_msg.= chr(0).chr(0).chr(0).chr(0);
	  else $binary_msg.= chr($parts[0]).chr($parts[1]).chr($parts[2]).chr($parts[3]);
	
	  socket_sendto($udpSocket, $binary_msg, strlen($binary_msg), 0, $obj->ip , 15556);
	}
	else echo "Kein Servermodul gefunden!<br>";
}

function configureServer($ip, $serialNumber, $gateway)
{
	createSocket();
	
	global $udpSocket;
	
	$binary_msg = "";
	$binary_msg.= chr(0xdf);
	$binary_msg.= chr(0xdf);
	$binary_msg.= chr(5);
	$binary_msg.= chr(5);
	$binary_msg.= chr(5);
	$binary_msg.= $gateway;
	
	for ($i=0;$i<strlen($serialNumber);$i++)
	{
		$binary_msg.= substr($serialNumber, $i, 1);
	}
	
	socket_sendto($udpSocket, $binary_msg, strlen($binary_msg), 0, $ip , 15556);
}

function closeClient($client)
{
	  $client->active=false;
	  $client->deviceId=-1;
	  $client->ip="";
	  socket_close($client->socket);
}

function logMe($message, $withTimeStamp=true)
{
	 global $debug;
	 
	 if ($debug==1)
	 {
	   if ($withTimeStamp) echo date("d.m.y H:i:s").": ";
	   echo $message."<br>";
	 }
}

function flushIt()
{
  for($i = 0; $i < 40; $i ++)
  {
    echo "          
    		                                                                              ";
    ob_end_flush ();
    ob_flush ();
    flush ();
  }
}
?>
